function [cl, CC] = cfun ( l, varargin) % idx, IAC)

% c(l) = 0,   i.e. l'l = 1.0

N = length(l);
G = N/3;
cl = zeros( G,1);            % memory allocation
CC = spalloc( G, N, N);      % memory allocation

for i=1:length(l)/3
    il = 3*(i-1)+(1:3);
    cl(i) = l(il)'*l(il) -1.0;
    CC( i,il)  = 2*l(il)';   %  l'l = 1    w.r.t.  l
end

return

