function [cg, AA, BB] = gfun(l,p, GGG, CCC, HHH)

% x'l = 0

% G = nnz(GGG);
G = sum(GGG(:));

U = length(p);
N = length(l);

cg = zeros( G,1);
AA = zeros( G,U);
BB = zeros( G,N);% sparse,  N);


if size(GGG,1)*3 ~= N || size(GGG,2)*3 ~= U
    whos GGG l p
    pause on
    pause
end

k = 0;

for ll=1:size( GGG,1)
    for pp =1:size( GGG,2)
        
        if GGG(ll,pp) == 2    % identity
            il = 3*(ll-1)+(1:3);
            ip = 3*(pp-1)+(1:3);

            [d, U, V] = reduction(  l(il), p(ip)  );

            k = k+2;
            cg( k-1:k)    = d;
            AA(k-1:k, ip) = U;
            BB(k-1:k, il) = V;
           
            
            %             % S(l)p = -S(p)*l = 0
            %             k = k+3;
            %             cg(k-2:k)     = +skew( l(il) ) *p(ip);
            %             AA(k-2:k, ip) = +skew( l(il) );
            %             BB(k-2:k, il) = -skew( p(ip) )';
        end
        
    end
end


for ll=1:size( GGG,1)
    for pp =1:size( GGG,2)

        if GGG(ll,pp) == 1     % incidence
            il = 3*(ll-1)+(1:3);
            ip = 3*(pp-1)+(1:3);

            k = k+1;
            cg(k   ) = l(il)'*p(ip);
            AA(k,ip) = l(il);
            BB(k,il) = p(ip)';
        end
    end
end


% whos cg AA BB

return
            