function S = skew (x)

% determines skew-symmetric matrix inducing the cross product
%
% S = skew (x)
%
% J. Meidow
% Institute for Photogrammetry
% Univ. of Bonn

%if length(x)~= 3
%   error('*** 3-vector required ***')
%end

S = [ ...
   0.0   -x(3)   +x(2); ...
   +x(3)  0.0    -x(1); ...
   -x(2) +x(1)    0.0 ...
      ];

return
