function [x, Cov_xx] = spherical_normalization( x, Cov_xx )

% spherical normalization of homogeneous vector
%
% [x, Cov_xx] = spherical_normalization( x, Cov_xx )
%
%     author: J. Meidow, FGAN-FOM
%
% 2005, Dec.:  initial code

if nargin==2
    J = (eye(3) - x*x'/(x'*x)) / norm(x);
    Cov_xx = J*Cov_xx*J';

    % J = jacobian(mfilename, 1e-7, 1 , x)
    % pause

end

x = x/norm(x);

return