function [ch, HH] = hfun( p )

% restrictions h(p) = 0 for parameters p only

FF = reshape( p, 3,3);              % fundamental matrix F

ch(1,1) = ( p'*p -1.0 )/2;          % i.e.  ||F|| = 1
ch(2,1) = det(FF);                  % det(F) = 0

% Jacobians
HH = zeros( 2, 9);                  % memory allocation
HH(1,:) = p';                       %  
HH(2,:) = reshape( adj(FF), 9, 1)'; % 

return