function [cg, AA, BB] = gfun( l,p, idx, IAC)

%   g(l,p) = 0,    i.e.    v'l = 0   with 3 vanishing points

G = length(idx);
U = 9;
N = length(l);

cg = zeros( G,1);
AA = zeros( G,U);
BB = spalloc( G, N, N);


for g=1:G
    iv = 3*( idx(g)-1)+(1:3);
    il = 3*(g-1)+(1:3);
    cg(g) = p( iv )'*l(il);
    AA( g, iv) = l(il)';      %  vk'li=0      w.r.t.  v
    BB( g, il) = p(iv);       %  vk'li=0      w.r.t.  l
end

return