function [cl, CC] = cfun(l, GGG, CCC,  HHH)

% l'*l = 1
%

% full(CCC)

N = length(l);
%C = length(l)/3
C = full( sum(CCC(:)) );

cl = zeros(C,1);
CC = spalloc( C, N, N);

k = 0;
for i=1:length(l)/3
    idx = 3*(i-1)+(1:3);
    k = k + 1;
    cl(i) = ( l(idx)'*l(idx)-1.0)/2;
    CC(i, idx) = l(idx)';
end

% incidence l/l
for i=1:size(CCC,1)
    for j=1:size(CCC,2)
        if CCC(i,j) == 2
            k = k + 2;
            idx1 = 3*(i-1) +(1:3);
            idx2 = 3*(j-1) +(1:3);
            [d,U,V] = reduction( l(idx1), l(idx2) );
            
            cl(k-1:k) = d;
            CC(k-1:k, idx1) = U;
            CC(k-1:k, idx2) = V;
        end
    end
end

return